<template>
    <div> 
      <v-container>
        <v-row no-gutters style="height: 60px">
          <v-col
            cols="12"
            xs="12"
            sm="9"
            md="9"
            lg="9"
            xl="9"
          >
            <datePicker @dateR="recupDate" />
          </v-col>
          <v-col
            cols="12"
            xs="12"
            sm="3"
            md="3"
            lg="3"
            xl="3"
          >
            <div style="display: flex; justify-content: end; margin-top: 30px; margin-right: 13px; height: 60px;">
               <v-btn 
                  class="primary" 
                  @click="openAddPcDialog"                          
                  color="white"
              >
                  <v-icon
                      left
                      dark
                  >
                      mdi-laptop
                  </v-icon>
                  Ajouter
              </v-btn>

              <ModalAjoutPC :dialog.sync="dialog" @call="submitForm"/>
               
            </div>
          </v-col>
        </v-row>
      </v-container>
      <Pagination :nbPage="nbPage" />
      <v-container>
        <v-row no-gutters>
          <v-col
            v-for="ordi in listOrdi"
            :key="ordi.id"
            cols="12"
            xs="12"
            sm="4"
            md="4"
            lg="4"
            xl="2"
          >
          <ordinateur :ordiname="ordi.name" :dataAttribution="ordi" :selectedDate="date"/>
          </v-col>
        </v-row>
    </v-container>
  </div>
</template>
<script>
import ordinateur from '../components/views/Ordinateur'
import datePicker from '../components/views/DatePicker'
import Pagination from '../components/views/Pagination'
import ModalAjoutPC from "../components/views/ModalAjoutPC"
import ApiService from '../services/ApiService'
import Utils from "../helpers/Utils";
import EventBusEnum from '../enum/EventBusEnum'

export default {
  name: 'Home',
  components: {
    ordinateur,
    datePicker,
    Pagination,
    ModalAjoutPC
  },
  data () {
    return {
      listOrdi: [],
      nbPage: 0,
      offset: 0,
      date: '',
      dialog: false,
    }
  },
  created () {
    this.getNbOrdi()
  },
  mounted () {
    let self = this
    Utils.eBusOnMethod(EventBusEnum.EVENT_PAGINATION, function (payLoad) {
        self.offset = (payLoad * 3) - 3
        self.getListOrdis(self.offset)
    });
  },
  methods: {
    openAddPcDialog () {
      this.dialog = true
      Utils.emitMethod(EventBusEnum.EVENT_ADD_POSTE, {offset: this.offset, posteName: this.posteName, getListOrdis: this.getListOrdis, getNbOrdi: this.getNbOrdi})
    },
    recupData (event) {
      this.listOrdi.push(event)
    },
    getListOrdis (offset) {
      this.listOrdi = []
      this.getNbOrdi()
      const params = { params:  {date: this.date, offset }}
      ApiService.get('/postes/list-ordi', params)
      .then(Utils.handleResponse)
      .then(response => {
        this.listOrdi = response.data.map(dat => {
          return dat
        })
      })
    },
    recupDate (date) {
      this.date = date
      this.getListOrdis(this.offset)
    },
    getNbOrdi () {
       ApiService.get('/postes/nb-poste')
        .then(Utils.handleResponse)
        .then(response => {          
          //Nombre de poste divisé par 3 (où 3 le nombre de poste par page)
            this.nbPage = Math.ceil(response.data / 3)
        })
    },
    submitForm (posteName) {
        const data = {name: posteName}
      ApiService.post('/postes', data)
      .then(Utils.handleResponse)
      .then(response => {  
        if(response.success) {
          this.getNbOrdi()        
          this.getListOrdis(this.offset)
          Utils.emitMethod(EventBusEnum.EVENT_SNACKBAR, {timeout:3000, message: response.message, show: true, color: 'green'})
          this.dialog = false
        } else {
          Utils.emitMethod(EventBusEnum.EVENT_SNACKBAR, {timeout:3000, message: response.message, show: true, color: 'red'})
        }
      })      
    },
  }
};
</script>

